Index: orxonox/trunk/src/importer/material.cc
===================================================================
--- orxonox/trunk/src/importer/material.cc	(revision 3453)
+++ orxonox/trunk/src/importer/material.cc	(revision 3454)
@@ -110,5 +110,5 @@
    \returns Material named mtlName if it is found. NULL otherwise.
 */
-Material* Material::search (char* mtlName)
+Material* Material::search(char* mtlName)
 {
   PRINTF(2)("Searching for material %s", mtlName);
Index: orxonox/trunk/src/importer/material.h
===================================================================
--- orxonox/trunk/src/importer/material.h	(revision 3453)
+++ orxonox/trunk/src/importer/material.h	(revision 3454)
@@ -31,5 +31,5 @@
   void init(void);
 
-  Material* search (char* mtlName);
+  Material* search(char* mtlName);
   bool select (void);
 
@@ -52,5 +52,4 @@
  
   void addTexturePath(char* pathName);
-  char* searchTextureInPaths(char* texName) const;
  // MAPPING //
   void setDiffuseMap(char* dMap);
Index: orxonox/trunk/src/importer/model.cc
===================================================================
--- orxonox/trunk/src/importer/model.cc	(revision 3453)
+++ orxonox/trunk/src/importer/model.cc	(revision 3454)
@@ -224,4 +224,8 @@
 }
 
+/**
+   \brief sets a name to the Model
+   \param name The name to set to this Model
+*/
 void Model::setName(const char* name)
 {
@@ -858,5 +862,7 @@
 }
 
-
+/**
+   \brief Builds a Sphere into the Model
+*/
 void Model::sphereModel()
 {
Index: orxonox/trunk/src/importer/model.h
===================================================================
--- orxonox/trunk/src/importer/model.h	(revision 3453)
+++ orxonox/trunk/src/importer/model.h	(revision 3454)
@@ -17,4 +17,5 @@
 using namespace std;
 
+//! Specification of different primitives the Model knows
 enum PRIMITIVE {PLANE, CUBE, SPHERE, CYLINDER};
 
Index: orxonox/trunk/src/importer/objModel.h
===================================================================
--- orxonox/trunk/src/importer/objModel.h	(revision 3453)
+++ orxonox/trunk/src/importer/objModel.h	(revision 3454)
@@ -1,4 +1,4 @@
 /*!
-  \file objmodel.h
+  \file objModel.h
   \brief Contains the OBJ-model Class, that reads in a Model from a .obj-file
 */
Index: orxonox/trunk/src/importer/texture.cc
===================================================================
--- orxonox/trunk/src/importer/texture.cc	(revision 3453)
+++ orxonox/trunk/src/importer/texture.cc	(revision 3454)
@@ -190,5 +190,4 @@
    \brief Loads a Texture to the openGL-environment.
    \param pImage The Image to load to openGL
-   \param texture The Texture to apply it to.
 */
 bool Texture::loadTexToGL (Image* pImage)
@@ -260,5 +259,5 @@
    \brief Makes the Programm ready to Read-in a texture-File
    1. Checks what type of Image should be imported
-   2. ToDO: Checks where to find the Image
+   \todo Checks where to find the Image
 */
 bool Texture::loadImage(char* imageName)
@@ -304,5 +303,4 @@
    \brief reads in a Windows BMP-file, and imports it to openGL.
    \param bmpName The name of the Image to load.
-   \param texture A pointer to the Texture which should be read to.
 */
 bool Texture::loadBMP (char* bmpName)
@@ -408,5 +406,4 @@
    \brief reads in a jpg-file
    \param jpgName the Name of the Image to load
-   \param texture a reference to the Texture to write the image to
 */
 bool Texture::loadJPG (char* jpgName)
@@ -508,5 +505,4 @@
    \brief reads in a tga-file
    \param tgaName the Name of the Image to load
-   \param texture a reference to the Texture to write the image to
 */
 bool Texture::loadTGA(const char * tgaName)
@@ -565,5 +561,4 @@
    \param filename the Name of the Image to load
    \param fTGA a Pointer to a File, that should be read
-   \param texture a reference to the Texture to write the image to
 */
 bool Texture::loadUncompressedTGA(const char * filename, FILE * fTGA)
@@ -639,5 +634,4 @@
    \param filename the Name of the Image to load
    \param fTGA a Pointer to a File, that should be read
-   \param texture a reference to the Texture to write the image to
 */
 bool Texture::loadCompressedTGA(const char * filename, FILE * fTGA)
@@ -816,15 +810,7 @@
 
 
-/*
-static int ST_is_power_of_two(unsigned int number)
-{
-  return (number & (number - 1)) == 0;
-}
-*/
-
 /**
    \brief reads in a png-file
    \param pngName the Name of the Image to load
-   \param texture a reference to the Texture to write the image to
 */
 bool Texture::loadPNG(const char* pngName)
Index: orxonox/trunk/src/importer/texture.h
===================================================================
--- orxonox/trunk/src/importer/texture.h	(revision 3453)
+++ orxonox/trunk/src/importer/texture.h	(revision 3454)
@@ -11,5 +11,4 @@
 
 #include "../stdincl.h"
-extern int verbose;
 #ifdef HAVE_SDL_SDL_IMAGE_H
 #include <SDL/SDL_image.h>
@@ -65,7 +64,7 @@
     GLubyte *data;  //!< The Image Data comes here! DANGER: uncompressed data.
   };
-  Image* pImage;
-  GLuint texture;
-  SDL_Surface* map;
+  Image* pImage;    //!< The data of an Image
+  GLuint texture;   //!< The Texture-ID of opengl from this Texture.
+  SDL_Surface* map; //!< The map SDL initializes for this element.
   char* searchTextureInPaths(char* texName) const;
   inline void swap(unsigned char &a, unsigned char &b);
@@ -73,6 +72,6 @@
   Texture(void);
   ~Texture(void);
-
-  inline GLuint getTexture(void) {return this->texture;} //!< \returns The textureID of this texture.
+  /** \returns The textureID of this texture.  */
+  inline GLuint getTexture(void) {return this->texture;} 
   bool loadTexToGL (Image* pImage);
 
@@ -90,5 +89,5 @@
   bool loadCompressedTGA(const char * filename, FILE * fTGA);
 
-  bool loadPNG(const char* pngName, GLuint* texture);
+  bool loadPNG(const char* pngName);
 #endif
 
Index: orxonox/trunk/src/importer/windowHandler.cc
===================================================================
--- orxonox/trunk/src/importer/windowHandler.cc	(revision 3453)
+++ orxonox/trunk/src/importer/windowHandler.cc	(revision 3454)
@@ -16,4 +16,10 @@
 #include "windowHandler.h"
 #include <stdio.h>
+
+/**
+   \brief Resizes the Window
+   \param width the new size in the width.
+   \param height the new size in the height.
+*/
 void WindowHandler::ReSizeGLScene(GLsizei width, GLsizei height) // Resize And Initialize The GL Window
 {
@@ -39,5 +45,7 @@
 }
 
-
+/**
+   \brief initializes openGL
+*/
 int WindowHandler::InitGL(GLvoid)										// All Setup For OpenGL Goes Here
 {
@@ -53,5 +61,7 @@
 }
 
-
+/**
+   \brief kills the window
+*/
 GLvoid WindowHandler::KillGLWindow(GLvoid) // Properly Kill The Window
 {
@@ -59,5 +69,13 @@
 }
 
-
+/**
+   \brief creates a new Window for the scene
+   \param title the name of the Window
+   \param width the width of the window
+   \param height the height of the window
+   \param bits the bits per pixel to use
+   \param fullscreenflag TRUE if fullscreen FALSE if windowed/
+   \returns FALSE if initialisation failed, TRUE otherwise
+*/
 BOOL WindowHandler::CreateGLWindow(char* title, int width, int height, int bits, BOOL fullscreenflag)
 {
Index: orxonox/trunk/src/importer/windowHandler.h
===================================================================
--- orxonox/trunk/src/importer/windowHandler.h	(revision 3453)
+++ orxonox/trunk/src/importer/windowHandler.h	(revision 3454)
@@ -1,2 +1,8 @@
+/*!
+  \file windowHandler.h
+  \brief contains the WindowHandler class for the minimal display system
+*/
+
+
 #ifndef _WINDOWHANDLER_H
 #define _WINDOWHANDLER_H
@@ -16,8 +22,9 @@
 #endif /* __WIN32__ */
 
-#define TRUE 1
-#define FALSE 0
-#define BOOL int
+#define TRUE 1     //!< define true
+#define FALSE 0    //!< define false
+#define BOOL int   //!< define BOOL
 
+//! A simple class to handle a minimal display system
 class WindowHandler
 {
@@ -27,5 +34,5 @@
     GLvoid KillGLWindow(GLvoid);
     BOOL CreateGLWindow(char* title, int width, int height, int bits, BOOL fullscreenflag);
-    SDL_Surface* screen;
+    SDL_Surface* screen;   //!< The screen to which to display the rendered stuff
   private:
     int InitGL(GLvoid);